JUCE: ListBoxModel Class Reference

JUCE

Public Member Functions | List of all members
ListBoxModel Class Referenceabstract
juce_gui_basics » widgets

A subclass of this is used to drive a ListBox. More...

`#include <juce_ListBox.h>`

Inheritance diagram for ListBoxModel:

## Public Member Functions
virtual | ~ListBoxModel ()=default
| Destructor. More...
virtual int | getNumRows ()=0
| This has to return the number of items in the list. More...
virtual void | paintListBoxItem (int rowNumber, Graphics &g, int width, int height, bool rowIsSelected)=0
| This method must be implemented to draw a row of the list. More...
virtual Component * | refreshComponentForRow (int rowNumber, bool isRowSelected, Component *existingComponentToUpdate)
| This is used to create or update a custom component to go in a row of the list. More...
virtual String | getNameForRow (int rowNumber)
| This can be overridden to return a name for the specified row. More...
virtual void | listBoxItemClicked (int row, const MouseEvent &)
| This can be overridden to react to the user clicking on a row. More...
virtual void | listBoxItemDoubleClicked (int row, const MouseEvent &)
| This can be overridden to react to the user double-clicking on a row. More...
virtual void | backgroundClicked (const MouseEvent &)
| This can be overridden to react to the user clicking on a part of the list where there are no rows. More...
virtual void | selectedRowsChanged (int lastRowSelected)
| Override this to be informed when rows are selected or deselected. More...
virtual void | deleteKeyPressed (int lastRowSelected)
| Override this to be informed when the delete key is pressed. More...
virtual void | returnKeyPressed (int lastRowSelected)
| Override this to be informed when the return key is pressed. More...
virtual void | listWasScrolled ()
| Override this to be informed when the list is scrolled. More...
virtual var | getDragSourceDescription (const SparseSet< int > &rowsToDescribe)
| To allow rows from your list to be dragged-and-dropped, implement this method. More...
virtual String | getTooltipForRow (int row)
| You can override this to provide tool tips for specific rows. More...
virtual MouseCursor | getMouseCursorForRow (int row)
| You can override this to return a custom mouse cursor for each row. More...

## Detailed Description

A subclass of this is used to drive a ListBox.

See also
  ListBox

## Constructor & Destructor Documentation

## ◆ ~ListBoxModel()

virtual ListBoxModel::~ListBoxModel | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getNumRows()

virtual int ListBoxModel::getNumRows | ( |  | ) |
| pure virtual

This has to return the number of items in the list.

See also
  ListBox::getNumRows()

Implemented in FileSearchPathListComponent, and TableListBox.

## ◆ paintListBoxItem()

virtual void ListBoxModel::paintListBoxItem | ( | int | rowNumber,
|  | Graphics & | g,
|  | int | width,
|  | int | height,
|  | bool | rowIsSelected
| ) |  |
| pure virtual

This method must be implemented to draw a row of the list.

Note that the rowNumber value may be greater than the number of rows in your list, so be careful that you don't assume it's less than getNumRows().

Implemented in FileSearchPathListComponent, and TableListBox.

## ◆ refreshComponentForRow()

virtual Component * ListBoxModel::refreshComponentForRow | ( | int | rowNumber,
|  | bool | isRowSelected,
|  | Component * | existingComponentToUpdate
| ) |  |
| virtual

This is used to create or update a custom component to go in a row of the list.

Any row may contain a custom component, or can just be drawn with the paintListBoxItem() method and handle mouse clicks with listBoxItemClicked().

This method will be called whenever a custom component might need to be updated - e.g. when the list is changed, or ListBox::updateContent() is called.

If you don't need a custom component for the specified row, then return nullptr. (Bear in mind that even if you're not creating a new component, you may still need to delete existingComponentToUpdate if it's non-null).

If you do want a custom component, and the existingComponentToUpdate is null, then this method must create a suitable new component and return it.

If the existingComponentToUpdate is non-null, it will be a pointer to a component previously created by this method. In this case, the method must either update it to make sure it's correctly representing the given row (which may be different from the one that the component was created for), or it can delete this component and return a new one.

The component that your method returns will be deleted by the ListBox when it is no longer needed.

Bear in mind that if you put a custom component inside the row but still want the listbox to automatically handle clicking, selection, etc, then you'll need to make sure your custom component doesn't intercept all the mouse events that land on it, e.g by using Component::setInterceptsMouseClicks().

Reimplemented in TableListBox.

## ◆ getNameForRow()

virtual String ListBoxModel::getNameForRow | ( | int | rowNumber | ) |
| virtual

This can be overridden to return a name for the specified row.

By default this will just return a string containing the row number.

## ◆ listBoxItemClicked()

virtual void ListBoxModel::listBoxItemClicked | ( | int | row,
|  | const MouseEvent & |
| ) |  |
| virtual

This can be overridden to react to the user clicking on a row.

See also
  listBoxItemDoubleClicked

## ◆ listBoxItemDoubleClicked()

virtual void ListBoxModel::listBoxItemDoubleClicked | ( | int | row,
|  | const MouseEvent & |
| ) |  |
| virtual

This can be overridden to react to the user double-clicking on a row.

See also
  listBoxItemClicked

Reimplemented in FileSearchPathListComponent.

## ◆ backgroundClicked()

virtual void ListBoxModel::backgroundClicked | ( | const MouseEvent & |  | ) |
| virtual

This can be overridden to react to the user clicking on a part of the list where there are no rows.

See also
  listBoxItemClicked

Reimplemented in TableListBox.

## ◆ selectedRowsChanged()

virtual void ListBoxModel::selectedRowsChanged | ( | int | lastRowSelected | ) |
| virtual

Override this to be informed when rows are selected or deselected.

This will be called whenever a row is selected or deselected. If a range of rows is selected all at once, this will just be called once for that event.

Parameters

  lastRowSelected | the last row that the user selected. If no rows are currently selected, this may be -1.

Reimplemented in FileSearchPathListComponent, and TableListBox.

## ◆ deleteKeyPressed()

virtual void ListBoxModel::deleteKeyPressed | ( | int | lastRowSelected | ) |
| virtual

Override this to be informed when the delete key is pressed.

If no rows are selected when they press the key, this won't be called.

Parameters

  lastRowSelected | the last row that had been selected when they pressed the key - if there are multiple selections, this might not be very useful

Reimplemented in TableListBox, and FileSearchPathListComponent.

## ◆ returnKeyPressed()

virtual void ListBoxModel::returnKeyPressed | ( | int | lastRowSelected | ) |
| virtual

Override this to be informed when the return key is pressed.

If no rows are selected when they press the key, this won't be called.

Parameters

  lastRowSelected | the last row that had been selected when they pressed the key - if there are multiple selections, this might not be very useful

Reimplemented in TableListBox, and FileSearchPathListComponent.

## ◆ listWasScrolled()

virtual void ListBoxModel::listWasScrolled | ( |  | ) |
| virtual

Override this to be informed when the list is scrolled.

This might be caused by the user moving the scrollbar, or by programmatic changes to the list position.

Reimplemented in TableListBox.

## ◆ getDragSourceDescription()

virtual var ListBoxModel::getDragSourceDescription | ( | const SparseSet< int > & | rowsToDescribe | ) |
| virtual

To allow rows from your list to be dragged-and-dropped, implement this method.

If this returns a non-null variant then when the user drags a row, the listbox will try to find a DragAndDropContainer in its parent hierarchy, and will use it to trigger a drag-and-drop operation, using this string as the source description, with the listbox itself as the source component.

See also
  DragAndDropContainer::startDragging

## ◆ getTooltipForRow()

virtual String ListBoxModel::getTooltipForRow | ( | int | row | ) |
| virtual

You can override this to provide tool tips for specific rows.

See also
  TooltipClient

## ◆ getMouseCursorForRow()

virtual MouseCursor ListBoxModel::getMouseCursorForRow | ( | int | row | ) |
| virtual

You can override this to return a custom mouse cursor for each row.

The documentation for this class was generated from the following file:

- juce_ListBox.h